#include "fire.h"

#ifdef Utilities
void DrawBoard(typePos *Position)
{
    char C[16] = "0PNKBBRQ";
    char ARR[256];
    int t, c, u;
    Send("      +---+---+---+---+---+---+---+---+\n");
    if (WriteLog)
    {
        log_file = fopen(log_filename, "a");
        fprintf(log_file, "      +---+---+---+---+---+---+---+---+\n");
        close_log();
    }
    for (t = R8; t >= R1; t--)
    {
        Send("   %i  |", t + 1);
        if (WriteLog)
        {
            log_file = fopen(log_filename, "a");
            fprintf(log_file, "   %i  |", t + 1);
            close_log();
        }
        for (c = FA; c <= FH; c++)
        {
            u = Position->sq[c + 8 * t];

            if (u >= 8)
            {
                Send("<%c>", C[u - 8]);
                if (WriteLog)
                {
                    log_file = fopen(log_filename, "a");
                    fprintf(log_file, "<%c>", C[u - 8]);
                    close_log();
                }
            }
            else if (u > 0)
            {
                Send(" %c ", C[u]);
                if (WriteLog)
                {
                    log_file = fopen(log_filename, "a");
                    fprintf(log_file, " %c ", C[u]);
                    close_log();
                }
            }
            else if ((c + t) & 1)
            {
                Send("   ");
                if (WriteLog)
                {
                    log_file = fopen(log_filename, "a");
                    fprintf(log_file, "   ");
                    close_log();
                }
            }
            else
            {
                Send(" . ");
                if (WriteLog)
                {
                    log_file = fopen(log_filename, "a");
                    fprintf(log_file, " . ");
                    close_log();
                }
            }
            Send("|");
            if (WriteLog)
            {
                log_file = fopen(log_filename, "a");
                fprintf(log_file, "|");
                close_log();
            }
        }
        Send("\n      +---+---+---+---+---+---+---+---+\n");
        if (WriteLog)
        {
            log_file = fopen(log_filename, "a");
            fprintf(log_file, "\n      +---+---+---+---+---+---+---+---+\n");
            close_log();
        }
    }
    Send("        a   b   c   d   e   f   g   h\n");
    if (WriteLog)
    {
        log_file = fopen(log_filename, "a");
        fprintf(log_file, "        a   b   c   d   e   f   g   h\n");
        close_log();
    }
    EmitFen(Position, ARR);
    Send("%s\n", ARR);
    if (WriteLog)
    {
        log_file = fopen(log_filename, "a");
        fprintf(log_file, "%s\n", ARR);
        close_log();
    }
}

uint64 Cnt[64];
#define InCheck \
  (Position->wtm ? Position->Dyn->wKcheck : Position->Dyn->bKcheck)
#define Illegal  \
  (!Position->wtm ? Position->Dyn->wKcheck : Position->Dyn->bKcheck)

static void perft(typePos *Position, int d, int h)
{
    typeMoveList LM[512], *lm;
    int i;

    if (InCheck)
        lm = EvasionMoves(Position, LM, 0xffffffffffffffff);
    else
    {
        lm = CaptureMoves(Position, LM, Position->OccupiedBW);
        lm = OrdinaryMoves(Position, lm);
    }

    for (i = 0; i < lm - LM; i++)
    {
        Make(Position, LM[i].move);
        Mobility(Position);

        if (!Illegal)
        {
            Cnt[h]++;

            if (d > 1)
                perft(Position, d - 1, h + 1);
        }
        Undo(Position, LM[i].move);
    }
}
void PERFT(typePos *Position, int d)
{
    int i;
    Mobility(Position);

    for (i = 0; i < 64; i++)
        Cnt[i] = 0;
    perft(Position, d, 1);

    for (i = d; i >= 2; i--)
        Send("%lld/", Cnt[i]);
    Send("%lld\n", Cnt[1]);

    if (WriteLog)
    {
        log_file = fopen(log_filename, "a");
        for (i = d; i >= 2; i--)
            fprintf(log_file, "%lld/", Cnt[i]);
        fprintf(log_file, "%lld\n", Cnt[1]);
        close_log();
    }
}
uint64 PERFD(typePos *Position, int n)
{
    int i;
    uint64 TOTAL = 0, TIME;
    typeMoveList LM[512], *lm;
    DrawBoard(Position);
    TIME = GetClock();
    Mobility(Position);

    if (InCheck)
        lm = EvasionMoves(Position, LM, 0xffffffffffffffff);
    else
    {
        lm = CaptureMoves(Position, LM, Position->OccupiedBW);
        lm = OrdinaryMoves(Position, lm);
    }

    for (i = 0; i < lm - LM; i++)
    {
        Make(Position, LM[i].move);
        Mobility(Position);

        if (!Illegal)
        {
            Send("%s ", Notate(LM[i].move, String1));
            if (WriteLog)
            {
                log_file = fopen(log_filename, "a");
                fprintf(log_file, "%s ", Notate(LM[i].move, String1));
                close_log();
            }
            PERFT(Position, n - 1);
            TOTAL += Cnt[n - 1];
        }
        Undo(Position, LM[i].move);
    }
    Send("TOTAL %lld  moves %ld  time: %lld us\n", TOTAL, lm - LM, GetClock() - TIME);
    if (WriteLog)
    {
        log_file = fopen(log_filename, "a");
        fprintf(log_file, "TOTAL %lld  moves %ld  time: %lld us\n", TOTAL, lm - LM, GetClock() - TIME);
        close_log();
    }
    return TOTAL;
}

void Perfd(typePos *Position, int d, uint64 n)
{
    uint64 u = PERFD(Position, d);

    if (u != n)
        ErrorEnd("Perfd failed: computed: %lld given: %lld", u, n);
}
#endif
